From 6ad53c9ba609a58897f76cad578b6f37cff0a53b Mon Sep 17 00:00:00 2001
From: Koen Kooi <koen@dominion.thruhere.net>
Date: Tue, 15 Jun 2010 19:34:53 +0200
Subject: [PATCH] configure.in: also pass down --target when using --host and --build

---
 configure.in |   21 +++++++++++++++++----
 1 files changed, 17 insertions(+), 4 deletions(-)

diff --git a/configure.in b/configure.in
index 4707537..74d0433 100644
--- a/configure.in
+++ b/configure.in
@@ -1433,6 +1433,7 @@ XB_CONFIG_MODULE([xbmc/lib/libPython/Python], [
     ./configure \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \
       --disable-ipv6 \
       --enable-unicode=ucs4 \
       --without-cxx \
@@ -1540,6 +1541,7 @@ XB_CONFIG_MODULE([xbmc/cores/dvdplayer/Codecs/libdts], [
     ./configure \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \      
       --disable-oss \
       --disable-solaris-audio \
       --disable-al-audio \
@@ -1559,6 +1561,7 @@ XB_CONFIG_MODULE([xbmc/cores/dvdplayer/Codecs/libdvd/libdvdcss], [
     ./configure \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \      
       --disable-doc \
       --enable-static \
       --with-pic
@@ -1581,6 +1584,7 @@ XB_CONFIG_MODULE([xbmc/cores/dvdplayer/Codecs/libdvd/libdvdread], [
       --prefix="${prefix}" --includedir="${includedir}" --libdir="${libdir}" --datadir="${datadir}" \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \      
       --enable-static \
       --disable-shared \
       --disable-strip \
@@ -1609,6 +1613,7 @@ XB_CONFIG_MODULE([xbmc/cores/dvdplayer/Codecs/libdvd/libdvdnav], [
       --with-dvdread-config="`pwd`/../libdvdread/obj/dvdread-config" \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \      
       --enable-static \
       --disable-shared \
       --cc="$CC"
@@ -1640,6 +1645,7 @@ XB_CONFIG_MODULE([xbmc/cores/dvdplayer/Codecs/liba52], [
     ./configure \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \      
       --with-pic \
       --disable-static \
       --enable-shared \
@@ -1677,7 +1683,8 @@ XB_CONFIG_MODULE([lib/libass], [
     CFLAGS="$CFLAGS -fPIC" \
     ./configure \
       --host=$host_alias \
-      --build=$build_alias
+      --build=$build_alias \
+      --target=$target_alias
   fi
 ], [$USE_EXTERNAL_LIBASS])
 
@@ -1697,6 +1704,7 @@ XB_CONFIG_MODULE([xbmc/lib/libid3tag/libid3tag],[
       --prefix="${prefix}" --includedir="${includedir}" --libdir="${libdir}" --datadir="${datadir}" \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \      
       --disable-static \
       --with-pic
   fi
@@ -1725,6 +1733,7 @@ XB_CONFIG_MODULE([xbmc/visualizations/Goom/goom2k4-0],[
       --prefix="${prefix}" --includedir="${includedir}" --libdir="${libdir}" --datadir="${datadir}" \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \      
       --disable-shared \
       --enable-static \
       --with-pic
@@ -1758,6 +1767,7 @@ if expr "X$host_cpu" : 'Xarm.*' > /dev/null; then :; else
       --prefix="${prefix}" --includedir="${includedir}" --libdir="${libdir}" --datadir="${datadir}" \
       --host=$host_alias \
       --build=$build_alias \
+      --target=$target_alias \      
       --without-xscreensaver \
       --disable-sound \
       --disable-cyclone \
@@ -1778,7 +1788,8 @@ XB_CONFIG_MODULE([xbmc/cores/dvdplayer/Codecs/libbdnav/], [
   else
     ./configure --without-openssl \
       --host=$host_alias \
-      --build=$build_alias
+      --build=$build_alias \
+      --target=$target_alias
   fi
 ], [0])
 
@@ -1789,7 +1800,8 @@ XB_CONFIG_MODULE([xbmc/lib/libapetag], [
   else
     ./configure \
       --host=$host_alias \
-      --build=$build_alias
+      --build=$build_alias \
+      --target=$target_alias
   fi
 ], [0])
 
@@ -1819,7 +1831,8 @@ XB_CONFIG_MODULE([lib/cpluff], [
   else
     ./configure --disable-nls \
       --host=$host_alias \
-      --build=$build_alias
+      --build=$build_alias \
+      --target=$target_alias
   fi
 ], [0])
 
-- 
1.6.6.1